<script lang="ts">
  import BoardC from "./components/Board.svelte";
  import StoneC from "./components/Stone.svelte";
  import {
    blackPlayerId,
    boardPlayerSide,
    isActing,
    whitePlayerId,
  } from "./utils";
  import { createEventDispatcher } from "svelte";
  import flipIconSrc from "./assets/flip_board.svg";

  const dispatch = createEventDispatcher();

  function dispatchAction(action: Action): void {
    dispatch("action", action);
  }

  export let playerId: PlayerId | null;
  export let state: GameState;

  let playerColor: PlayerColor | null;
  $: if (blackPlayerId(state) === playerId) {
    playerColor = "b";
  } else if (whitePlayerId(state) === playerId) {
    playerColor = "w";
  } else {
    playerColor = null;
  }

  let activeSquare: { board: number; square: Square } | null;

  function handleStoneClick(board: number, square: Square) {
    if (
      activeSquare &&
      activeSquare.board === board &&
      activeSquare.square === square
    ) {
      activeSquare = null;
    } else {
      activeSquare = { board, square };
    }

    if (state.phase.t === "aggressive" && isActing(state.phase, playerColor)) {
      dispatchAction({ t: "aggressive", board, square });
      activeSquare = null;
    }
  }

  function handleSquareClick(board: number, square: Square) {
    if (activeSquare && isActing(state.phase, playerColor)) {
      if (state.phase.t === "passive") {
        dispatchAction({
          t: "passive",
          mv: {
            board,
            from: activeSquare.square,
            to: square,
          },
        });
      }
    }

    activeSquare = null;
  }

  function handleUndo() {
    dispatchAction({ t: "undoPassive" });
  }

  let flipped: boolean;
  $: {
    flipped = playerColor === "w";
  }

  function handleFlip() {
    flipped = !flipped;
  }
</script>

<div class="wrapper" class:flipped>
  <div class="player">
    <gs6-player-box
      userid={whitePlayerId(state)}
      thinking={isActing(state.phase, "w")}
    >
      <div slot="after-name" class="player-color">
        <StoneC color={"w"} />
      </div>
    </gs6-player-box>
    {#if playerColor === "w" && state.phase.t === "aggressive" && isActing(state.phase, playerColor)}
      <div class="undo-button">
        <button class="secondary" on:click={handleUndo}>Undo</button>
      </div>
    {/if}
  </div>
  <div class="boards">
    <div class="flip-button">
      <button class="secondary" on:click={handleFlip}>
        <img class="flip-icon" src={flipIconSrc} alt="Flip board" />
      </button>
    </div>

    {#each state.boards as stones, idx}
      <BoardC
        {stones}
        {flipped}
        dark={idx % 2 === 0}
        activeSquare={activeSquare && activeSquare.board === idx
          ? activeSquare.square
          : null}
        passiveMove={state.phase.t === "aggressive" &&
        state.phase.passive.board === idx
          ? state.phase.passive
          : null}
        disabled={!isActing(state.phase, playerColor) ||
          (state.phase.t === "aggressive" &&
            state.phase.passive.board % 2 === idx % 2) ||
          (state.phase.t === "passive" && boardPlayerSide(idx) !== playerColor)}
        on:click:square={(event) => handleSquareClick(idx, event.detail)}
        on:click:stone={(event) => handleStoneClick(idx, event.detail)}
        {playerColor}
      />
    {/each}
  </div>
  <div class="player">
    <gs6-player-box
      userid={blackPlayerId(state)}
      thinking={isActing(state.phase, "b")}
    >
      <div slot="after-name" class="player-color">
        <StoneC color={"b"} />
      </div>
    </gs6-player-box>

    {#if playerColor === "b" && state.phase.t === "aggressive" && isActing(state.phase, playerColor)}
      <div class="undo-button">
        <button class="secondary" on:click={handleUndo}>Undo</button>
      </div>
    {/if}
  </div>

  {#if state.phase.t === "gameComplete"}
    <div class="summary panel">
      <gs6-user userid={state.phase.winner} />
      wins!
    </div>
  {/if}
</div>

<style>
  .wrapper {
    position: relative;
    height: 100%;
    width: 100%;

    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;

    transition: transform 0.75s;
  }
  .wrapper.flipped {
    transform: rotate(180deg);
  }

  .player {
    margin-top: 1em;
    margin-bottom: 1em;
    display: flex;

    transition: transform 0.5s;
    position: relative;
  }

  .flipped .player {
    transform: rotate(-180deg);
  }

  .boards {
    position: relative;
    width: 75%;
    min-width: 25em;
    max-width: 40em;
    display: grid;
    grid-template-rows: 1fr 1fr;
    grid-template-columns: 1fr 1fr;
  }

  .boards > :global(*) {
    margin: 2.5%;
  }

  .flip-button {
    position: absolute;
    top: 50%;
    right: 0;
    transform: translate(calc(100% + 1.5em), -100%);
  }

  .flipped .flip-button {
    transform: translate(calc(100% + 1.5em), -100%) rotate(180deg) scaleX(-1);
  }

  .flip-button > button {
    height: 2em;
    width: 2em;
    text-align: center;
    padding: 0;

    display: grid;
    place-content: center;
  }

  .flip-icon {
    display: inline-block;
    width: 2em;

    transform: scale(0.66) rotate(90deg);
  }

  .undo-button {
    position: absolute;
    top: 50%;
    transform: translate(calc(100% + 1em), -50%);
    right: 0;
  }

  .summary {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    transition: transform 0.5s;
  }
  .flipped .summary {
    transform: translate(-50%, -50%) rotate(-180deg);
  }

  div.player-color {
    display: inline-block;
    margin-left: 0.25em;
    width: 1.25em;
    transform: translateY(0.15em);
  }
</style>
